/* Included from snd.cc. This is neither a module nor a standalone program. */

#include <sys/ioctl.h>
#include <stdlib.h>
#include "oss.c"
static char RandBuf[0x400];
static void BuildRand(void)
{
    for(unsigned a=0;a<0x400;)RandBuf[a++]=(rand()/4173)%2;
}
static int randnum(int ind)
{
    return RandBuf[ind];
}
#include "filters.c"
static unsigned GetInterPValue
   (const vector<unsigned char> &Buf, unsigned pos, unsigned div, unsigned speed)
{
#if 0 /* NO INTERPOLATION */
	speed=speed;
	return Buf[(pos/div) % Buf.size()];
#endif
#if 0 /* LINEAR INTERPOLATION */
	speed=speed;
    unsigned base = Buf[(pos        /div) % Buf.size()];
    unsigned next = Buf[((pos+div-1)/div) % Buf.size()];

    unsigned midpos = pos % div;

    return (next*midpos + base*(div-1-midpos)) / div;
#endif
#if 1 /* SLUGGISH INTERPOLATION [9=Cubic] */
	const FilterInfo &Filter = Filters[9];
	double scale_factor = max(1.0, speed / (double)div);
	double support      = max(0.5, scale_factor * Filter.support);
	if(support <= 0.5) { support = 0.5 + 1E-12; scale_factor = 1.0; }
	double *weight = (double *)alloca((sizeof(double)) * ((int)support*2+3));
	double (*const filterfun)(double) = Filter.function;
	const double center = pos / (double)div;
	int start = (int)(0.5 + center - support);
	int end   = (int)(0.5 + center + support);
	register double density = 0;
	int n = 0;
	for(int i = start; i < end; ++i)
		density += (weight[n++] = filterfun((i-center+0.5) / scale_factor) / scale_factor);
    if(density != 0.0)
        for(register int i=0; i<n; ++i)
            weight[i] /= density; /* normalize */
    register double result = 0.0;
    for(register unsigned i=0, k=start; i<n; ++i)
    	result += weight[i] * Buf[k++ % Buf.size()];
    return (int)result;
#endif
}

static void PlaySND(const song &song)
{
    vector<unsigned> waveptr(song.channelcount);

    int Bits=16, Stereo=0, Rate=44100;
    unsigned a;
    BuildRand();
    SetSoundSettings(1,&Bits,&Stereo,&Rate);
    
    for(a=0; a<song.rownum; ++a)
    {
        unsigned slen = Rate / song.rate;
        
        vector<short> Buf(slen);
        
        for(unsigned c=0; c<song.channelcount; ++c)
        {
            const channel &tmp = song.ChanPtr(a, c);
            if(!tmp.wavelen)continue;
            
            if(false
            //|| c==0
            //|| c==1
            //|| c==2
            //|| c==3
            //|| c==4
              )continue;
            
            for(unsigned p=0; p<slen; ++p)
            {
                signed char pha=0;
                int v;
                if(tmp.type == channel::tri)
                {
                    static const signed char wave[32] =
                    {0,1,2,3,4,5,6,7,7,6,5,4,3,2,1,0,
                    0,-1,-2,-3,-4,-5,-6,-7,-7,-6,-5,-4,-3,-2,-1,0};

                    pha = wave[(waveptr[c]/100000) & 31];
                }
                else if(tmp.type == channel::sqr)
                {
                    pha = (((waveptr[c]/100000) & 15) < tmp.sample) ? 15 : -15;
                }
                else if(tmp.type == channel::rnd)
                {
                    pha = randnum((waveptr[c]/400000) % 0x400) ? 5 : -5;
                }
                else if(tmp.type == channel::pcm)
                {
                    if(tmp.age==0)waveptr[c]=0;
                    const vector<unsigned char> &smp = song.dpcmcache[tmp.sample];
                    if(smp.size())
                    {
                    	pha = GetInterPValue(smp, waveptr[c], 100000, 4000000 / tmp.wavelen);
                        pha = (pha - 0x80) * 3;
                    }
                }
                
                v = pha * tmp.vol;
                Buf[p] += v*30;
                waveptr[c] += 4000000 / tmp.wavelen;
            }
        }
        fwrite(&Buf[0], sizeof(Buf[0]), Buf.size(), stdout);
    }
}
